function np_0init, date, surfix
common nparams, prefixi, prefixo, calib, dl, pathi, patho, t_comp_path, dfcomp, filelst, ftime, filecomp, c2048, chipsz, $
      x0, x1, x2, x3, y0, y1, nx, ny, rois, nf, nfpw, nw, binx, biny, count,imrot, nfr, nxr,nyr,nwr,  xind, ss, ssx, ssy, $
      offsw, offset, positionv, qsign, usign, vsign, phase, phasev, header, lcen, platform
    

  
  file_mkdir, patho
  

 
     ;side job: copy position files ____________  
   istherepos=file_search(patho+'position'+dl+'frtimes_*.txt')
   
   if n_elements(istherepos) le 1 then begin


    print, 'copying position files...'

    if calib then pindex=file_search(pathi+'calib'+dl+'frtimes_*.txt') $
      else pindex=file_search(pathi+'frtimes_*.txt')
  
    if n_elements(pindex) ge 1 then begin
      file_mkdir, patho+'position'
      file_copy, pindex, patho+'position', /overwrite
      print, 'done cpy position'
  
    endif
  endif
  ;end copy position
  
  
    if calib then filelst=file_search(pathi+'calib'+dl+'10830\*_c_*.fts*') else filelst=file_search(pathi+'10830\*_i_*.fts*');TEMP
    
    if nm1(filelst)+1 le 0 then stop
      
      filecomp=bytarr(n_elements(filelst),2)
      ftime=strarr(n_elements(filelst))
    for i=0, nm1(filelst) do begin
      if strmid(filelst[i], strlen(filelst[i])-2, 2) eq 'fz' then begin
        ftime[i]=strmid(filelst[i], strlen(filelst[i])-23, 13) 
        filecomp[i,0]=1
       endif  else begin
        ftime[i]=strmid(filelst[i], strlen(filelst[i])-20, 13)
        filecomp[i,0]=0
        endelse
    endfor
    
 ;check wavelength number
  nf_array=intarr(n_elements(filelst), 4)
  ny_array=intarr(n_elements(filelst), 4)

  print, 'checking median number of frames...'
  for i=0, nm1(filelst) do begin
    headers=headfits(filelst[i], /sil)
    if fxpar(headers, 'naxis') ne 0 then begin
    nf_array[i,0]=fxpar(headers, 'naxis3')
    nf_array[i,1]=fxpar(headers, 'startz')
    nf_array[i,2]=fxpar(headers, 'endz')
    nf_array[i,3]=fxpar(headers, 'zincremt')
    
    ny_array[i,0]=fxpar(headers, 'y0')
    ny_array[i,1]=fxpar(headers, 'y1')
    ny_array[i,2]=fxpar(headers, 'naxis1')
    ny_array[i,3]=fxpar(headers, 'naxis2')
    endif else begin
      headers=headfits(filelst[i], /exten, /sil)
    nf_array[i,0]=fxpar(headers, 'znaxis3')
    nf_array[i,1]=fxpar(headers, 'startz')
    nf_array[i,2]=fxpar(headers, 'endz')
    nf_array[i,3]=fxpar(headers, 'zincremt')
    
      ny_array[i,0]=fxpar(headers, 'y0')
      ny_array[i,1]=fxpar(headers, 'y1')
      ny_array[i,2]=fxpar(headers, 'znaxis1')
      ny_array[i,3]=fxpar(headers, 'znaxis2')
    endelse
    
  endfor

  nfr=fix(median(nf_array[*,0]))
  startz=fix(median(nf_array[*,1]))
  endz=fix(median(nf_array[*,2]))
  zinc=fix(median(nf_array[*,3]))
  nfpw=18
  nwr=nfr/nfpw
  if nfr mod nfpw ne 0 then stop
  print, 'nwr=', nwr, 'endz=', endz



  y0r=fix(median(ny_array[*,0]))
  y1r=fix(median(ny_array[*,1]))
  nxr=fix(median(ny_array[*,2]))
  nyr=fix(median(ny_array[*,3]))
  ;ny=y1-y0+1
  
  if y1r eq 0 then y1r=y0r+nyr-1
  
  nxywcut=1
  ;if ~calib then nxywcut=1 else nxywcut=0
  if nxywcut then nw=((1000<endz)-startz)/zinc+1 else nw=(endz-startz)/zinc+1
       
  nf=nw*18

 if nxr eq 2048 and nyr eq 1024 then rois=1 else rois=0

  ;if nyr eq 1 then begin
;
;      y0r=0
;      y1r=chipsz-1
;      nyr=chipsz

;  endif
        print, 'y0r=', y0r, ' y1r=', y1r, 'nxr=', nxr, ' nyr=', nyr
  xgen=findgen(nxr)
  if rois and nxywcut then begin & x0=252 & x1=971 & x2=1136 & x3=1855 & y0=152 & y1=871 & $
    if x1-x0 ne x3-x2 then stop & nx=2*(x1-x0+1) & ny=y1-y0+1 & $
    xind=where((xgen ge x0 and xgen le x1) or (xgen ge x2 and xgen le x3))  &   endif else begin
    x0=0 & x1=chipsz/2-1 & x2=chipsz/2 & x3=chipsz-1 & y0=y0r & y1=y1r & nx=chipsz & ny= chipsz & xind=xgen & endelse

  if calib and rois then begin & x0=0 & x1=chipsz/2-1 & x2=chipsz/2 & x3=chipsz-1 $
    & y0=y0r & y1=y1r & nx=chipsz & ny= y1r-y0r+1 & xind=xgen & endif
    
  if ~rois then stop
  
if calib then begin
  if c2048 then binx=64 else binx=512
  biny=2
endif else begin
   binx=1
  biny=1

endelse
  
  save, filelst, ftime, filecomp, $
      x0, x1, x2, x3, y0, y1, nx, ny, rois, nf, nfpw, nw, binx, biny, $
      nfr, nxr,nyr,nwr,  xind, filename=patho+date+'_init_params.sav'
      
  return, 1
  
end

function np_1makednf;, fname

common nparams, prefixi, prefixo, calib, dl, pathi, patho, t_comp_path, dfcomp, filelst, ftime, filecomp, c2048, chipsz, $
      x0, x1, x2, x3, y0, y1, nx, ny, rois, nf, nfpw, nw, binx, biny, count,imrot, nfr, nxr,nyr,nwr,  xind, ss, ssx, ssy, $
      offsw, offset, positionv, qsign, usign, vsign, phase, phasev, header, lcen, platform
   
  flatindex=file_search(pathi+'calib'+dl+'10830'+dl+'bbsoniris*_f_*.fts*')
  darkindex=file_search(pathi+'calib'+dl+'10830'+dl+'bbsoniris*_d_*.fts*')
  

  nflat=fix(n_elements(flatindex))

  ;make dark (dark should be one file)
  
  if strmid(darkindex[0], strlen(darkindex[0])-2, 2) eq 'fz' then begin
    fout=niris_decomp(darkindex[0], t_comp_path)
    if fout ne '' then darkindex[0]=fout
  endif
  
  
  darkraw=readfits(darkindex[0], dh, /sil)
  
  
  dark=intarr(nxr, nyr)
  dark=fix(median(darkraw, dimension=3))
  !null=temporary(darkraw)
  file_mkdir, patho+'calib'
  writefits, patho+'calib'+dl+'dark.fts', dark, dh
  
  
  ;make flat
  flatarray=intarr(nxr,nyr,nwr)
  itemp=intarr(nxr,nyr,nfr)
  
  for i=0, nflat-1 do begin
    if strmid(flatindex[i], strlen(flatindex[i])-2, 2) eq 'fz' then begin
      fout=niris_decomp(flatindex[i], t_comp_path)
      if fout ne '' then flatindex[i]=fout else stop
    endif
    
    if (i eq 0) then begin
      
      itemp+=(readfits(flatindex[i], fh, /silent)/nflat) 
      
    endif else begin
      
      itemp+=(readfits(flatindex[i],/silent)/nflat)
      
    endelse
  endfor
  
    
  
  for i=0, nwr-1 do flatarray[*,*,i]=total(itemp[*,*,i*nfpw:i*nfpw+15], 3)/16
 !null=temporary(itemp)
  
  
  fdfac=intarr(nwr)

  fd=intarr(nxr,nyr,nwr)
  for k=0, nwr-1 do begin
    fd[*,*,k]=flatarray[*,*,k]-dark
    if c2048 and ~imrot then fdfac[k]=median(fd[800:1200,*,k]) 
    if c2048 and imrot and ~rois then fdfac[k]=median(fd[*,800:1200,k])
    if c2048 and imrot and rois then fdfac[k]=median(fd[*,*,k])
    if ~c2048 then fdfac[k]=median(fd[*,*,k])  
  endfor
  
  !null=temporary(dark)

  window, xs=nxr, ys=nyr
  tv, bytscl(flatarray[*,*,1])
  plots, [x0,x1,x1,x0,x0], [y0,y0,y1,y1,y0], /device
  plots, [x2,x3,x3,x2,x2], [y0,y0,y1,y1,y0], /device
  snap=tvrd(/true)
  write_png, patho+'calib'+dl+'flat.png', bytscl(flatarray[*,*,1])
  write_png, patho+'calib'+dl+'flat2.png', snap
  writefits, patho+'calib'+dl+'flat.fts', fix(flatarray), fh
  writefits, patho+'calib'+dl+'fdfac.fts', fdfac
  
  
  !null=temporary(flatarray)
  

  print, 'flat & dark made...'

return, 1
end


function np_2flatndark, i, dark0, flat0, fdfac, running_erase=running_erase, flat_env=flat_env

common nparams, prefixi, prefixo, calib, dl, pathi, patho, t_comp_path, dfcomp, filelst, ftime, filecomp, c2048, chipsz, $
      x0, x1, x2, x3, y0, y1, nx, ny, rois, nf, nfpw, nw, binx, biny, count,imrot, nfr, nxr,nyr,nwr,  xind, ss, ssx, ssy, $
      offsw, offset, positionv, qsign, usign, vsign, phase, phasev, header, lcen, platform
        
  

fname=filelst[i]



    if filecomp[i,0] then begin
      
    ftest=(file_test(patho+'df'+dl+'df_'+ftime[i]+'.fts')) or (file_test(patho+'df'+dl+'df_'+ftime[i]+'.fts.fz'))
    
    if ftest then begin
      print, 'df_'+ftime[i]+' already exists. skipping...'
      return, 1
    endif      
      
         
      
      fout=niris_decomp(fname, t_comp_path)
      if fout ne '' then begin
        fname=fout
      endif else begin
        print, 'error: decompression failed...skipping...'
        return, 0
      endelse
    endif
    
    ftest=(file_test(patho+'df'+dl+'df_'+ftime[i]+'.fts')) or (file_test(patho+'df'+dl+'df_'+ftime[i]+'.fts.fz'))
    
    if ftest then begin
      print, 'df_'+ftime[i]+' already exists. skipping...'
      return, 1
    endif


    jumpredo:
    
    temp=readfits(fname, header, /silent)
    img=intarr(nx,ny,nf)
    if file_test(patho+'offset.sav') then begin 
      restore, patho+'offset.sav'
       img[0:nx/2-1,*,*]=temp[x0:x1,y0:y1,0:nf-1] & img[nx/2:*,*,*]=temp[x2+offset[0]:x3+offset[0],y0+offset[1]:y1+offset[1],0:nf-1]
       endif else img=temp[xind,y0:y1,0:nf-1]
    
    !null=temporary(temp)
    if fxpar(header, 'naxis3') ne nfr then begin
      print, 'frame number does not match for'+string(i)+'.'
      return, 0
    endif


    ;modify header for pixel scale
    pixscale=fxpar(header, 'cdelt1')
    pixscalex=pixscale*binx
    pixscaley=pixscale*biny

    fxaddpar, header, 'cdelt1', pixscalex
    fxaddpar, header, 'cdelt2', pixscaley

    flat=intarr(nx,ny,nw)
    dark=intarr(nx,ny)
    
    if file_test(patho+'offset.sav') then begin 
       flat[0:nx/2-1,*,*]=flat0[x0:x1,y0:y1,0:nw-1] & flat[nx/2:*,*,*]=flat0[x2+offset[0]:x3+offset[0],y0+offset[1]:y1+offset[1],0:nw-1]
       dark[0:nx/2-1,*]=dark0[x0:x1,y0:y1] & dark[nx/2:*,*]=dark0[x2+offset[0]:x3+offset[0],y0+offset[1]:y1+offset[1]]
       endif else begin & flat=flat0[xind,y0:y1,0:nw-1] & dark=dark0[xind,y0:y1] & endelse
        
    for j=0, nf-1 do img[*,*,j]= fix(float(img[*,*,j]-dark)/float(flat[*,*,j/nfpw]-dark)*fdfac[j/nfpw]*5.);/add*5 for testing

    if ~calib and flat_env then begin
      envelope=float(smooth(median(img[*,*,0:15], dimension=3), 200, /edge_truncate))
      env_norm=envelope/median(envelope)
      
      for j=0, nf-1 do img[*,*,j]=fix(float(img[*,*,j])/env_norm)
      
      
      
    endif

    if ~calib and (~file_test(patho+'ss.sav') or ~file_test(patho+'offset.sav')) then begin
      fraw=img[*,*,0]
      fraw0=median(fraw, 7)
      sdf=stdev(fraw0-fraw)
      ss=where(abs(fraw0-fraw) ge (sdf*3.5), count)
      ssx=ss mod nx & ssy=ss/nx
      
      if file_test(patho+'offset.sav') then save, ss, ssx, ssy, count, filename=patho+'ss.sav'
    endif else if ~calib then restore, patho+'ss.sav'
    
   if ~calib then begin  
     if count gt 0 then begin
      imgtemp=img
      for pnt=0, nm1(ss) do  imgtemp[ssx[pnt],ssy[pnt],*]=median(median(img[(ssx[pnt]-3)>0:(ssx[pnt]+3)<(nx-1),(ssy[pnt]-3)>0:(ssy[pnt]+3)<(ny-1),*], dimension=2), dimension=1)
      img=imgtemp
      !null=temporary(imgtemp)
     endif
   endif
    
    ;_______crop_
    if ~file_test(patho+'offset.sav') and ~calib then begin 
      imga=img[0:nx/2-1,*,0] & imgb=reverse(img[nx/2:*,*,0])
      offset=fix(ch_alignoffset(imga, imgb))
      offset[1]*=(-1)
      print, offset
      save, offset, filename=patho+'offset.sav'
      write_png, patho+'diff.png', bytscl(imga-shift(imgb, offset[0], -offset[1]))
      goto, jumpredo
    endif
  
    if calib then begin
      imgc=intarr(nx/binx,ny/biny, nf)
      for j=0, nf-1 do begin
        if c2048 then begin
          for jj=0, nx/binx-1 do imgc[jj,*,j]=rebin(median(img[64*jj:64*jj+63,*,j], dimension=1), ny/biny)
        endif else begin
          imgc[0,*,j]=rebin(median(img[30:481,*,j], dimension=1), 512)
          imgc[1,*,j]=rebin(median(img[541:993,*,j], dimension=1), 512)
        endelse
      endfor
    endif

   curt=systime()


 
   fxaddpar, header, 'xcen', 'refer to bbso log at http://www.bbso.njit.edu/cgi-bin/logs'
   fxaddpar, header, 'ycen', 'same as above'
   fxaddpar, header, 'instrume', 'niris'
   expt=fxpar(header, 'exposure')
   framerate=1000./(expt+1.)
   fxaddpar, header, 'frrate', framerate
   fxaddpar, header, 'history', 'processed dark/flat on '+curt
   fxaddpar, header, 'frmswvln', '16+2(extra buffer)'
   startz=fxpar(header, 'startz')
   endz=fxpar(header, 'endz')
   zinc=fxpar(header, 'zincremt')
   st2wv=0.003163
   fxaddpar, header, 'refwv', 15648.4983, 'wavelength at zero step (angstrom)'
   fxaddpar, header, 'startwv',startz*st2wv, 'starting wavelength from refwv (angstrom)'
   fxaddpar, header, 'endwv', endz*st2wv, 'ending wavelength from refwv (angstrom)'
   fxaddpar, header, 'incwv', zinc*st2wv, 'increment per wavelength (angstrom)'
   
   fxaddpar, header, 'comment', 'orignal header created by s. shumko'
   fxaddpar, header, 'comment', 'header partially modified by k. ahn'


   
   if calib then writefits, patho+'df'+dl+'dfc_'+ftime[i]+'.fts', imgc, header  $
    else begin
   ; window, 0, xs=nx/binx, ys=ny/biny
   ; tvscl, bytscl(img[*,*,1], 3000, 7000)
    write_png, patho+'df'+dl+'df_'+ftime[i]+'.png', bytscl(img[*,*,1])
   ; writefits, patho+'df'+dl+'df_'+ftime[i]+'.fts', fix(rebin(img, nx/binx, ny/biny, nf)), header
     
    
    endelse
   if dfcomp and platform eq 'win' then begin
      spawn,'d:\fitsio\fpack -r -c -d '+patho+'df\df_'+ftime[i]+'.fts', /hide
      filecomp[i,1]=1
    endif
   if dfcomp and platform eq 'X' then begin
      spawn, 'fpack -r -c -d '+patho+'df\df_'+ftime[i]+'.fts'
      filecomp[i,1]=1
   endif
   
   if filecomp[i,0] and running_erase then begin
    file_delete, fout
    print, 'deleted '+fout
   endif
   
    help, filecomp[i,0], running_erase

    return, fix(rebin(img, nx/binx, ny/biny, nf))
end

function np_3align, i, img
  
common nparams, prefixi, prefixo, calib, dl, pathi, patho, t_comp_path, dfcomp, filelst, ftime, filecomp, c2048, chipsz, $
      x0, x1, x2, x3, y0, y1, nx, ny, rois, nf, nfpw, nw, binx, biny, count,imrot, nfr, nxr,nyr,nwr,  xind, ss, ssx, ssy, $
      offsw, offset, positionv, qsign, usign, vsign, phase, phasev, header, lcen, platform
      
      help, img
   

;    if calib then dfname=file_search(patho+'df'+dl+'dfc_'+ftime[i]+'.fts') $
;      else dfname=file_search(patho+'df'+dl+'df_'+ftime[i]+'.fts')
;
;
;    if calib then itest=file_test(patho+'final'+dl+'c_'+ftime[i]+'.fts') $
;      else itest=file_test(patho+'final'+dl+'i_'+ftime[i]+'.fts')
;
;    if itest and (i ne 0) then begin
;      print, 'df '+ftime[i]+' already processed. skipping...'
;      goto, jump2
;    endif

       
;   if n_params() eq 1 then begin
;    ;test files & read img
;    if filecomp[i,1] then begin
;      fout=niris_decomp(dfname, t_comp_path)
;      if fout ne '' then begin
;        acomp=1
;      endif else begin
;        print, 'error: failed to find the decompressed file...'
;        stop
;      endelse
;    endif else acomp=0
;
;    if acomp then img=readfits(file_search(fout), header, /silent) else img=readfits(dfname, header, /silent) 
;
;   endif
          
    if ~(fxpar(header, 'naxis3') eq nfr or fxpar(header, 'naxis3') eq nf) then begin
      print, 'skipping '+ftime[i]+' due to nf mismatch'
      goto, jump2
    endif
    
    ;determin line center
   if ~calib then begin
    mdarr=fltarr(nw)
    for w=0, nw-1 do mdarr[w]=median(img[*,*,w*18:w*18+15])
    lcen=(where(mdarr eq min(mdarr)))[0]
    if lcen eq 0 or lcen eq nw-1 then begin
	print, 'Lcen value unreasonable. Skipping...', ftime[i]
		return, 0
    endif
    fxaddpar, header, 'lcen', lcen, 'measured line center index from the median line profiles'
    
   endif
    
    
    imga=img[0:nx/binx/2-1,*,*] & imgb=reverse(img[nx/binx/2:*,*,*])
    !null=temporary(img)
    
 
    
    ;rotate image 
    if ~calib then begin
      if ~(file_test(patho+'_shifts.sav'))then begin
          istd=10e10
          for k=-2., 2., 0.05 do begin
            imgbt=rot(imgb[*,*,0], k, /interp)
            istdt=stddev(imga[*,*,0]-imgbt)
             if istdt lt istd then begin
                    istd=istdt & bk=k
                    print, istd, k
                    ;tv, bytscl(imga[*,*,0]-imgbt, -100, 100)
                    
                    write_png, patho+'diff2.png', bytscl(imga[*,*,0]-imgbt, -100, 100)
                  endif
            endfor
       save, bk, filename=patho+'_shifts.sav'
        endif else restore, filename=patho+'_shifts.sav'
    endif
    
   if ~calib then for j=0, nf-1 do imgb[*,*,j]=rot(imgb[*,*,j], bk, /interp)
      
    ;start image alignment_____________________________

   
   if ~calib then begin
    ref=imga[nx/8:nx*3/8,ny/4:ny*3/4,0]
    sou=imgb[nx/8:nx*3/8,ny/4:ny*3/4,0]
    offset2=ch_alignoffset(sou, ref)
    for j=0, nf-1 do    imgb[*,*,j]=ch_shift_sub(imgb[*,*,j], -offset2[0], -offset2[1])
    ;tv, bytscl(imga[*,*,nf-1]-imgb[*,*,nf-1], -100, 100)
   endif
    
 


    ;destretch____________________________________________
    if ~calib then begin; destrech only when used as i data
      ;if binx ne 2 or biny ne 2 then stop
      kernel=bytarr(50/binx, 50/biny)
      

      ret=fltarr(2,2)
      ret2=fltarr(2,2)
      
      ret_arr=fltarr(2,nx/2/50,ny/50,16)  
      
    
    
    
      for j=0, 15 do begin
        temp_arr=reg(imgb[*,*,j], imga[*,*,j], kernel, ret, deb=3)
        ret_arr[*,*,*,j]=ret[*,*,*,0]
      endfor
      ret_all=median(ret_arr, dimension=4)

      lcen=fxpar(header, 'lcen')
      print, 'lcen=', lcen
      for j=0, nf-1 do imgb[*,*,j]=doreg(imgb[*,*,j], ret[*,*,*,1], ret_all)
  
  
      for j=0, nf-1 do begin
        if j mod nfpw le 15 and (j lt (lcen-2)*18 or j ge (lcen+2)*18) then begin
          imga[*,*,j]=reg(imga[*,*,j], imga[*,*,0], kernel, ret2, deb=0)
          imgb[*,*,j]=doreg(imgb[*,*,j], ret2[*,*,*,1], ret2[*,*,*,0])
        endif 
        
        if j mod nfpw le 15 and (j ge (lcen-2)*18 and j lt (lcen+2)*18) then begin
          imga[*,*,j]=reg(imga[*,*,j], imga[*,*,(j/nfpw-1)*18], kernel, ret2, deb=0)
          imgb[*,*,j]=doreg(imgb[*,*,j], ret2[*,*,*,1], ret2[*,*,*,0])
        endif 
      endfor


    endif

img=intarr(nx/binx,ny/biny,nf)
img[0:nx/binx/2-1,*,*]=imga
img[nx/binx/2:*,*,*]=imgb
!null=temporary(imga)
!null=temporary(imgb)


    ;end of image alignment___________________________________
  return, img
  jump2:
  
  
end

function np_3_9getphase, i

common nparams, prefixi, prefixo, calib, dl, pathi, patho, t_comp_path, dfcomp, filelst, ftime, filecomp, c2048, chipsz, $
      x0, x1, x2, x3, y0, y1, nx, ny, rois, nf, nfpw, nw, binx, biny, count,imrot, nfr, nxr,nyr,nwr,  xind, ss, ssx, ssy, $
      offsw, offset, positionv, qsign, usign, vsign, phase, phasev, header, lcen, platform

   exposure=15.4
    t_drift=0.;15.
    ph_drift=t_drift/exposure*22.5/2.

  qsign=fltarr(nf)
  usign=fltarr(nf)
  vsign=fltarr(nf)

  for jj=0, nf-1 do begin
    if (jj mod 4 eq 0) or (jj mod 4 eq 3) then qsign[jj]=1. else qsign[jj]=-1.
    if (jj mod 4 eq 0) or (jj mod 4 eq 1) then usign[jj]=1. else usign[jj]=-1.
  endfor


  qwt=!pi/1.6
  uwt=!pi/1.6
  vwt=!pi/1.6

  posoffset=-2300. 
  
  
   ;start position data processing________________

    ;get position data
    if file_test(patho+'position'+dl+'frtimes_20'+ftime[i]+'.txt') then $
    readcol, patho+'position'+dl+'frtimes_20'+ftime[i]+'.txt', f='i,f', n, position, /sil else begin
	print, 'no position file for ',ftime[i],'skipping...'
	return, 0
     endelse

    ;skip this loop if position file is corrupted
    if n_elements(n) eq 0 or n_elements(where (position eq 0)) gt 110 then begin
      print, 'postion file corrupted for '+ftime[i]+'. skipping...'
      return, 0
    endif

    ;skip this loop if position number is not same as nf
    if n_elements(n) lt nfr then begin
       print, 'position file nf mismatch. Skipping...', ftime[i]
       return, 0
    endif

    position+=posoffset

    ;correct for negative step values
    for j=0, nf-1 do begin
      if (position[j] lt 0) then position[j]+=25600
      if (position[j] gt 25600) then position[j]-=25600
    endfor

    ;determine phase of modulation at zero step position
    all_angle=position/25600*360d
    med_phase=median(all_angle mod 22.5); 0<= med_phase < 22.5
    abs_array=abs(all_angle - med_phase)
    zindex_arr=where(abs_array eq min(abs_array))
    zindex=zindex_arr[0] mod 16

    phase=((360.-(zindex+1)*22.5) + med_phase) mod 360.;0<= phase  <360
    phasev=((phase + 11.25) mod 22.5) - 11.25; -11.25 <= phasev <11.25
    shiftv= fix((phase - phasev)/22.5);0<= shiftv =< 16


  vsign(*)=0.
    for jj=0, nf-1 do begin
      if (jj mod 8 ge 4) then vsign[jj]=1. else vsign[jj]=-1.
    endfor

    vsign=shift(vsign, 16-shiftv)
    vsign[0:15]=vsign[16:31]
        
       ;end of position data processing___________________
    
return, 1

end

function np_4stokes, i, img=img

common nparams, prefixi, prefixo, calib, dl, pathi, patho, t_comp_path, dfcomp, filelst, ftime, filecomp, c2048, chipsz, $
      x0, x1, x2, x3, y0, y1, nx, ny, rois, nf, nfpw, nw, binx, biny, count,imrot, nfr, nxr,nyr,nwr,  xind, ss, ssx, ssy, $
      offsw, offset, positionv, qsign, usign, vsign, phase, phasev, header, lcen, platform

  qwt=!pi/1.6
  uwt=!pi/1.6
  vwt=!pi/1.6


  
    isig=intarr(nx/2/binx,ny/biny, nw); & isig(*)=0
    qsig=intarr(nx/2/binx,ny/biny, nw); & qsig(*)=0
     qsigt=intarr(nx/2/binx, ny/biny, nw); & qsigt(*)=0
    usig=intarr(nx/2/binx,ny/biny, nw); & usig(*)=0
    vsig=intarr(nx/2/binx,ny/biny, nw); & vsig(*)=0
    tsig=intarr(nx/2/binx,ny/biny, nw, 4)
    
    isig(*)=0 & qsig(*)=0 & qsigt(*)=0 & usig(*)=0 & vsig(*)=0     ;initialize all the signal arrays

    a=img[0:nx/binx/2-1,*,*] & b=img[nx/binx/2:*,*,*]
    !null=temporary(img)

    for j=0, nf-1 do begin
      if(j mod nfpw le 15) then begin
          isig[*,*,j/nfpw] += (a[*,*,j]+b[*,*,j])/16
          qsig[*,*,j/nfpw] += (a[*,*,j]-b[*,*,j])*qsign[j]*qwt/16
          usig[*,*,j/nfpw] += (a[*,*,j]-b[*,*,j])*usign[j]*uwt/16
          vsig[*,*,j/nfpw] += (a[*,*,j]-b[*,*,j])*vsign[j]*vwt/16
      endif
    endfor

    !null=temporary(a)
    !null=temporary(b)

;compensate for phase drift caused by modulator
    qsigt=qsig
    for j=0, nf-1, nfpw do begin
        qsig[*,*,j/nfpw]=cos(4.*phase/!radeg)*qsigt[*,*,j/nfpw]-sin(4.*phase/!radeg)*usig[*,*,j/nfpw]
        usig[*,*,j/nfpw]=sin(4.*phase/!radeg)*qsigt[*,*,j/nfpw]+cos(4.*phase/!radeg)*usig[*,*,j/nfpw]
        vsig[*,*,j/nfpw]/=cos(2.*phasev/!radeg)  

    endfor


    file_mkdir, patho+'final'
    tsig[*,*,*,0]=isig
    tsig[*,*,*,1]=qsig
    tsig[*,*,*,2]=usig
    tsig[*,*,*,3]=vsig

    !null=temporary(isig) & !null=temporary(qsig) & !null=temporary(usig) & !null=temporary(vsig)

    curt=systime()
    fxaddpar, header, 'history', 'created stokes map at '+curt
    fxaddpar, header, 'history', 'changed file type to int'
    
 if calib then writefits, patho+'final'+dl+'C_'+ftime[i]+'.fts', tsig, header ;$
  ;else writefits, patho+'final'+dl+'I_'+ftime[i]+'.fts', tsig, header
 return, tsig
 
end

function np_5calib, img, date, i

common nparams, prefixi, prefixo, calib, dl, pathi, patho, t_comp_path, dfcomp, filelst, ftime, filecomp, c2048, chipsz, $
      x0, x1, x2, x3, y0, y1, nx, ny, rois, nf, nfpw, nw, binx, biny, count,imrot, nfr, nxr,nyr,nwr,  xind, ss, ssx, ssy, $
      offsw, offset, positionv, qsign, usign, vsign, phase, phasev, header, lcen, platform






path=prefixo+date+dl
cpath=prefixo
if date ge '20170101' then msimdate='20170413' else msimdate='20160715'

if file_test(path+'final'+dl+'cal_'+ftime[i]+'.fts') then begin
  print, 'cal file already exists...for '+ftime[i]
  goto, jump5
endif

jan=0
feb=31
mar=feb+28;or 29
apr=mar+31
may=apr+30
jun=may+31
jul=jun+30
aug=jul+31
sep=aug+31
oct=sep+30
nov=oct+31
dec=nov+30

month_tab=[jan, feb, mar, apr, may, jun, jul, aug, sep, oct, nov, dec]
obs_mon=strmid(date,4,2)
obs_day=strmid(date,6,2)
dobs=month_tab[obs_mon-1]+obs_day


loadct, 0, /sil
!p.font=2
!p.charsize=1.5



;backcorr=0
sdocomp=0
;display parameters
target=2

case target of 
 1: begin & lo=-0.01 & hi=0.01 & end ;qs
 2: begin & lo=-0.03 & hi=0.03 & end ;ordinary
 3: begin & lo=-0.05 & hi=0.05 & end   ;sp
 4: begin & lo=-1 & hi=1 & end;cal
endcase


nw=n_elements(img[0,0,*,0])
print, 'nw=', nw

wv=23





;load simulated m
  mmed=readfits(cpath+msimdate+dl+'Msim'+msimdate+'.fts', /sil);was .fts

  danglesim=23.5*sin((dobs-(mar+22))*2.*!pi/365.)+90.
  delsim=2.*danglesim/!radeg
  rotdelsim=[[1,0,0,0],[0, cos(delsim),-1.*sin(delsim), 0],[0, sin(delsim), cos(delsim), 0],[0,0,0,1]]

rsp=-0.005
ret3=330/!radeg
ret4=329/!radeg

mt4=[[1, rsp, 0, 0], [rsp, 1, 0,0], [0,0,cos(ret3), -1.*sin(ret3)], [0,0, sin(ret3), cos(ret3) ]]
mt3=[[1, rsp, 0, 0], [rsp, 1, 0,0], [0,0,cos(ret4), -1.*sin(ret4)], [0,0, sin(ret4), cos(ret4) ]]

;interpolate for sun transit time
allday=findgen(365)+1.
sundate=[jan, feb, mar, apr, may, jun, jul, aug, sep, oct, nov, dec]+23
suntime=18.+[59., 61., 54., 46., 44., 50., 54., 50., 40., 32., 34., 47.]/60.
suntransit=interpol(suntime, sundate, allday)

  stamp=16.+findgen(100)*8./100.
  msim=fltarr(4,4,n_elements(stamp))

th45=-90./!radeg;-90
  rot45=[[1,0,0,0],[0, cos(th45),-1.*sin(th45), 0],[0, sin(th45), cos(th45), 0],[0,0,0,1]]
t=[[1, rsp, 0, 0], [rsp, 1, 0,0], [0,0,cos(ret3), -1.*sin(ret3)], [0,0, sin(ret3), cos(ret3) ]]

for r=0, nm1(stamp) do begin
  thsim=2.*(stamp[r]-suntransit[dobs-1])*15./!radeg
  rotthsim=[[1,0,0,0],[0, cos(thsim),-1.*sin(thsim), 0],[0, sin(thsim), cos(thsim), 0],[0,0,0,1]]

  msim[*,*,r]= mmed ## rotthsim ## mt4 ## rotdelsim ## mt3 ;## rot45 ## t ##t

endfor

window, 0, xs=1024, ys=1024
!p.multi=[0,4,4]


for k=0, 3 do begin
  for h=0, 3 do begin
    if h eq 0 or k eq 0 then begin
        plot, stamp, msim[h,k,*], yr=[-0.1, 0.1], xr=[17,23],psym=2, /xst
    endif else begin
        plot, stamp, msim[h,k,*], yr=[-1, 1], xr=[17,23],psym=2, /xst
    endelse
  endfor
endfor

snap=tvrd()
write_png, path+'m_'+date+'.png',  snap



  mgf=msim


  
  isize=size(img)
  
  
  out=fltarr(isize[1],isize[2],isize[3], isize[4])
  
  


  time=fxpar(header, 'time-obs')
  hr=strmid(time, 0,2)
  mi=strmid(time, 3,2)
  se=strmid(time, 6,2)
  timef=hr+mi/60.+se/3600.
  
  m=fltarr(4,4)
  m[0,0]=1.
    
  

  for h=0, 3 do begin
    for k=0, 3 do begin
      m[k,h]=interpol(mgf[k,h,*], stamp, timef)
    
    endfor
  endfor




  mi=invert(m)
;temp
print, m
print, 'mi='
print, mi

  
  
  ;multiply with inverse m
  for lwv=0, isize[3]-1 do begin
  for j=0, isize[1]-1 do begin
    for k=0, isize[2]-1 do begin
  ;    for k=0,12 do begin
      out[j,k,lwv,*] = mi  ## reform(img[j,k,lwv,*])
  ;    endfor
    endfor
  endfor
  endfor


fxaddpar, header, 'comment', msimdate
  if median(out[*,*,0,0]) gt 32000. then stop
  writefits, path+'final'+dl+'cal_'+ftime[i]+'.fts', fix(out), header
  ;write_png, path+'final'+dl+'cal_'+ftime[i]+'.png', 
 
return, fix(out)

jump5:
return, 0

end

function np_6sndcalib, i, img

common nparams, prefixi, prefixo, calib, dl, pathi, patho, t_comp_path, dfcomp, filelst, ftime, filecomp, c2048, chipsz, $
      x0, x1, x2, x3, y0, y1, nx, ny, rois, nf, nfpw, nw, binx, biny, count,imrot, nfr, nxr,nyr,nwr,  xind, ss, ssx, ssy, $
      offsw, offset, positionv, qsign, usign, vsign, phase, phasev, header, lcen, platform
  


  
 ;_______________________________________extract crosstalk 
 
lcen=fxpar(header, 'lcen') 
 
wmargin=20<(nw-1-lcen<lcen)

help, wmargin
q=img[*,*,*,1]
u=img[*,*,*,2]
v=img[*,*,*,3]

qmed=median(q[0:nx/4,*,nw-13:nw-4])
umed=median(u[0:nx/4,*,nw-13:nw-4])
vmed=median(v[0:nx/4,*,nw-13:nw-4])


print, qmed, umed, vmed



q-=qmed
u-=umed
v-=vmed




qaratio=1e10

fs=-0.5 & fe=0.5 & fi=0.1

niter=7

qfout=1e10

qfoutt=0

while niter gt 0 and abs(fi) ge 0.00001 do begin
  qfoutt=qfout
for f=fs, fe, fi do begin
  
  
  qv=(q-f*v)[*,*,(lcen-wmargin)>0:(lcen+wmargin)<(nw-1)];need to change w lcen
  
  qsign0=((qv[*,*,wmargin] lt 0)*2-1) 
  qsn=intarr(nx/2,ny,2*wmargin+1) 
  for wv=0, 2*wmargin do  qsn[*,*,wv]=qsign0   
 
  qvs=qsn*qv
  qvssign=qvs ge 0 
  qvsl=total((qvs*qvssign)[*,*,0:wmargin],3) 
  qvsr=total((qvs*qvssign)[*,*,wmargin:2*wmargin],3) 
  
  
          
  
  qaratiot=median(abs(qvsr-qvsl)/(abs(qvsr+qvsl))) 
  
  if abs(qaratiot) lt abs(qaratio) then begin
    qaratio=qaratiot
    qfout=f
  ;  print, 'q ', qaratio, qfout, median(qvsl), median(qvsr)
  endif
    
    
endfor

fs= qfout-fi & fe=qfout+fi 
fi=(fe-fs)/10.
print, 'ratio change ',qaratio ,fs, fe, fi
niter--
endwhile

;_____________________________________________

uaratio=1e10

fs=-0.5 & fe=0.5 & fi=0.1

niter=7

ufout=1e10

ufoutt=0

while niter gt 0 and abs(fi) ge 0.00001 do begin
  ufoutt=ufout
for f=fs, fe, fi do begin
  
  
  uv=(u-f*v)[*,*,lcen-wmargin:lcen+wmargin]
  
  usign0=((uv[*,*,wmargin] lt 0)*2-1) 
  usn=intarr(nx/2,ny,2*wmargin+1) 
  for wv=0, 2*wmargin do  usn[*,*,wv]=usign0   
 
  uvs=usn*uv
  uvssign=qvs ge 0 
  uvsl=total((uvs*uvssign)[*,*,0:wmargin],3) 
  uvsr=total((uvs*uvssign)[*,*,wmargin:2*wmargin],3) 
  
  
          
  
  uaratiot=median(abs(uvsr-uvsl)/(abs(uvsr+uvsl))) 
  
  if abs(uaratiot) lt abs(uaratio) then begin
    uaratio=uaratiot
    ufout=f
  ;  print, 'u ', uaratio, ufout, median(uvsl), median(uvsr)
  endif
    
    
endfor

fs= ufout-fi & fe=ufout+fi 
fi=(fe-fs)/10.
print, 'ratio change u ',uaratio, fs, fe, fi
niter--
endwhile






print, qfout, ufout



 q=(q-qfout*v)
 u=(u-ufout*v)

;____________________________________________________

vquout=1e10
vqumout=1e10



fvout1=1e10
fvout2=1e10

;fvarr=fltarr(101,101)
;k=0

fv1s=-0.5 & fv1e=0.5 & fv1i=0.1
fv2s=-0.5 & fv2e=0.5 & fv2i=0.1

niterv=3
while niterv ge 0 do begin
for fv1=fv1s, fv1e, fv1i do begin 
  for fv2=fv2s, fv2e, fv2i do begin
  
 
  vqut=stddev((v-fv1*q-fv2*u)[*,*, lcen])
  vqutm=mean(((v-fv1*q-fv2*u)[*,*, lcen])^2)
  ;;;;;fvarr[k++]=vqut
  
  
  
  
  if vqut lt vquout then begin
    vquout=vqut
    vqumout=vqutm
    fvout1=fv1 & fvout2=fv2
    print, 'vquout=',vquout, vqumout, fvout1, fvout2
  endif
    
    endfor
endfor

fv1s=fvout1-fv1i & fv1e=fvout1+fv1i 
fv2s=fvout2-fv2i & fv2e=fvout2+fv2i
fv1i=(fv1e-fv1s)/10. & fv2i=(fv2e-fv2s)/10.

;print, fvout1, fvout2, fv1s, fv1e, fv2s , fv2e, fv1i, fv2i
niterv--
endwhile

print, fvout1, fvout2

v=v-fvout1*q-fvout2*u

qmed=median(q[0:nx/4,*,nw-13:nw-4])
umed=median(u[0:nx/4,*,nw-13:nw-4])
vmed=median(v[0:nx/4,*,nw-13:nw-4])


print, qmed, umed, vmed



q-=qmed
u-=umed
v-=vmed

img[*,*,*,1]=q
img[*,*,*,2]=u
img[*,*,*,3]=v

save, qfout, ufout, fvout1, fvout2, filename=patho+'final'+dl+'fout'+ftime[i]+'.sav'
;save, fvarr, filename=patho+'final\fvarr'+ftime[i]+'.sav'
writefits, patho+'final'+dl+'cals_'+ftime[i]+'.fts', fix(img), header
window, xs=nx, ys=ny/2
tv, rebin(bytscl(img[*,*,0,0]), nx/4, ny/2), 0
tv, rebin(bytscl(img[*,*,lcen,1], -100,100), nx/4, ny/2),1
tv, rebin(bytscl(img[*,*,lcen,2], -100,100),nx/4, ny/2),2
tv, rebin(bytscl(img[*,*,lcen+(nw-1-lcen)*0.4,3], -100,100),nx/4,ny/2),3
snap=tvrd()
write_png, patho+'final'+dl+'snap_'+ftime[i]+'.png', snap
return, img


end






function nirispipeline_20160615_10830, darray

   ;darray=['20150621','i','', 'H']
  
common nparams, prefixi, prefixo, calib, dl, pathi, patho, t_comp_path, dfcomp, filelst, ftime, filecomp, c2048, chipsz, $
      x0, x1, x2, x3, y0, y1, nx, ny, rois, nf, nfpw, nw, binx, biny, count,imrot, nfr, nxr,nyr,nwr,  xind, ss, ssx, ssy, $
      offsw, offset, positionv, qsign, usign, vsign, phase, phasev, header, lcen, platform
 

  date=darray[0]
  surfix=darray[2]
  calib=darray[1] eq 'c'
  drive=darray[3]
        
  platform='win'
  set_plot, platform
  if platform eq 'win' then dl='\' else dl='/'
  
  if platform eq 'win' then begin
    
    prefixi='\\RA\ra3\';drive+':\NIRIS_RAW\'
    prefixo=drive+':\NIRIS_data\'
    print, prefixi
    t_comp_path='D:\n_temp' 
    
    year=strmid(date,0,4)
    month=strmid(date,4,2)
    day=strmid(date,6,2)
    
    case month of
      '01':monc='jan'
      '02':monc='feb'
      '03':monc='mar'
      '04':monc='apr'
      '05':monc='may'
      '06':monc='jun'
      '07':monc='jul'
      '08':monc='aug'
      '09':monc='sep'
      '10':monc='oct'
      '11':monc='nov'
      '12':monc='dec'
      
    endcase
    
    pathi=prefixi+year+dl+month+dl+day+dl+strmid(year,2,2)+monc+day+'_niris'+dl
    
    patho=prefixo+date+dl+surfix
    
  
    
  endif else begin
  
    prefixi='/'+drive+'/'
    prefixo='/ra1/2015/processed_niris_data/'
  
    t_comp_path='/ra1/2015/processed_niris_data/temp'
      
    year=strmid(date,0,4)
    month=strmid(date,4,2)
    day=strmid(date,6,2)
    
    case month of
    '01':monc='jan'
    '02':monc='feb'
    '03':monc='mar'
    '04':monc='apr'
    '05':monc='may'
    '06':monc='jun'
    '07':monc='jul'
    '08':monc='aug'
    '09':monc='sep'
    '10':monc='oct'
    '11':monc='nov'
    '12':monc='dec'
  
    endcase

    pathi=prefixi+year+dl+month+dl+day+dl+strmid(year,2,2)+monc+day+'_niris'+dl
   
    patho=prefixo+date+dl


  endelse
  

  file_mkdir, t_comp_path
  
  
  running_erase=1
  flat_env=1
  dfcomp=0
  
  c2048=1 & chipsz=2048
  imrot=1
  

  cutwv=1
  offsw=0
  offset=[0,0]

if file_test(patho+date+'_init_params.sav') then  restore, patho+date+'_init_params.sav' $
   else result0=np_0init(date, surfix)


if file_test(patho+'calib'+dl+'flat.fts') eq 0 then result1=np_1makednf()


  dark=readfits(patho+'calib'+dl+'dark.fts', /silent)
  flat=readfits(patho+'calib'+dl+'flat.fts', fh, /silent)
  fdfac=readfits(patho+'calib'+dl+'fdfac.fts', /silent)
  
file_mkdir, patho+'df'
file_mkdir, patho+'inv'

for i=0, nm1(filelst) do begin
   print, ftime[i]
 ; if ~file_test(patho+'inv'+dl+'nirisinv_'+ftime[i]+'.fts') then begin
     
  if ~file_test(patho+'final'+dl+'cals_'+ftime[i]+'.fts') then begin
    
    
  ;if ~file_test(patho+'final'+dl+'I_'+ftime[i]+'.fts') then begin
    
  result2=np_2flatndark(i, dark, flat, fdfac, running_erase=running_erase, flat_env=flat_env)
  help, result2
  resiz=size(result2)
  if resiz[0] eq 0 then begin
  print, 'result2=', result2
    if result2 le 0 then goto, jump4 else begin
      img=readfits(patho+'df'+dl+'df_'+ftime[i]+'.fts',header)
      img=np_3align(i, img)
    endelse
  endif else img=np_3align(i, result2)

  if (size(img))[0] eq 0 and img[0] le 0 then goto, jump4
  
  result3=np_3_9getphase(i)
  if result3 eq 0 then goto, jump4
  img=np_4stokes(i, img=img)
  
  ;endif else img=readfits(patho+'final'+dl+'I_'+ftime[i]+'.fts', header)
  
  if ~calib then begin
    img=np_5calib(img, date, i)
    
    
    img=np_6sndcalib(i, img)
    endif ;else img=readfits(patho+'final'+dl+'cals_'+ftime[i]+'.fts', header, /sil)
  
  ;parmap=niris_inv(img, header)
  ;writefits, patho+'inv'+dl+'nirisinv_'+ftime[i]+'.fts', parmap
  
   endif;~calib
   
 ; endif else print, 'inversion file exists for '+ftime[i]
  
  
  jump4:
endfor





return, img

end
